package ppt;

public class RTPMessage{
	int seqNumber;
	long timeStamp;
	long ssrc;
	byte[] data;
	boolean markerBit;
	int payload;
	
	public RTPMessage(byte[] message){
		int firstByte =  0;
		int secondByte = 0;
		int thirdByte =  0;
		int fourthByte = 0;
		payload = (0x000000FF & ((int)message[1]));
		if (payload>127){
			payload-=128;
			markerBit = true;
		}else{
			markerBit = false;
		}

		firstByte = (0x000000FF & ((int)message[2]));
		secondByte = (0x000000FF & ((int)message[3]));
		seqNumber  = ((int) (firstByte <<8| secondByte))& 0xFFFFFFFF;
		firstByte = (0x000000FF & ((int)message[4]));
		secondByte = (0x000000FF & ((int)message[5]));
		thirdByte = (0x000000FF & ((int)message[6]));
		fourthByte = (0x000000FF & ((int)message[7]));
		timeStamp  = ((long) (firstByte << 24| secondByte << 16	| thirdByte << 8	| fourthByte))& 0xFFFFFFFFL;

		firstByte = (0x000000FF & ((int)message[8]));
		secondByte = (0x000000FF & ((int)message[9]));
		thirdByte = (0x000000FF & ((int)message[10]));
		fourthByte = (0x000000FF & ((int)message[11]));
		ssrc  = ((long) (firstByte << 24| secondByte << 16	| thirdByte << 8	| fourthByte))& 0xFFFFFFFFL;
	}

	public String toString(){
		return new String("marker:"+markerBit+" seqNumber:"+seqNumber+" timeStamp:"+timeStamp+" payload:"+payload);
	}
}

