package ppt;

import java.io.*;
import java.util.*;

public class Recorder implements RecordFullScreenInterface
{
	DataOutputStream os;
	long startTime;
	
	public Recorder(String filename){
		createFile(filename);	
	}

	public Recorder(){
		createFile();
	}

	public void createFile(){
		Calendar cal = new GregorianCalendar();
		String s="AS_RECORD_"+(cal.get(Calendar.MONTH)+1)+"_"+cal.get(Calendar.DAY_OF_MONTH)+"_"+cal.get(Calendar.YEAR)+"_"+
			cal.get(Calendar.HOUR_OF_DAY)+"_"+cal.get(Calendar.MINUTE)+"_"+cal.get(Calendar.SECOND)+".rtp";
		createFile(s);
	}
	
	public void createFile(String filename){
		try
		{
			os = new DataOutputStream(new FileOutputStream(filename));
			String magic="#!rtpplay1.0 0.0.0.0/6000\n";
			os.writeBytes(magic);
			os.writeInt(0);
			os.writeInt(0);
			os.writeInt(0);
			os.writeShort((short)6000);
			os.writeShort((short)0);
			startTime=System.currentTimeMillis();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	public synchronized int write(byte[] packet,int offset,int length,int timeStamp,boolean isRTP){
		try
		{
			length += 8;
			byte[] len = new byte[2];
			len[0]=(byte)(0xFF & (length>>8));
			len[1]=(byte)(0xFF & (length));
			//os.write(len,0,len.length);
            os.writeShort(length);

			length -= 8;
			len[0]=(byte)(0xFF & (length>>8));
			len[1]=(byte)(0xFF & (length));
			//if (isRTP) os.write(len,0,len.length);
			//else os.write(len,0,len.length);
			if (isRTP) os.writeShort(length);
			else os.writeShort(0);

			//os.writeShort((short)(length+8));
			//os.writeShort((short)(length));
			os.writeInt(timeStamp);
			int current=os.size();
			os.write(packet,offset,length);
			return os.size()-current;
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return -1;
	}

	public int write(byte[] packet,int timeStamp){
		return write(packet,0,packet.length,timeStamp,true);
	}

	public int write(byte[] packet)
	{
		return write(packet,0,packet.length,(int)(System.currentTimeMillis()-startTime),true);
	}

	public int write(byte[] packet,boolean isRTP)
	{
		return write(packet,0,packet.length,(int)(System.currentTimeMillis()-startTime),isRTP);
	}

	//public void finished(){;}

	public void close(){
		try
		{
			os.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public static void main(String[] args){
		Recorder r= new Recorder();
		r.write(new byte[172],0);
		r.close();
	}

}