package ppt;

import java.awt.*;
import java.awt.image.*;
import javax.imageio.stream.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.nio.*;
import java.nio.channels.*;
import javax.imageio.*;
import java.util.*;

public class AppShareClient
{
	int width = 669, height = 386;
	int MAX_WINDOW=20;
	AppShareWindow windows[] = new AppShareWindow[MAX_WINDOW];
	DataOutputStream eventStream;
	RTPStream rs;
	int dl=0;
	long totalByte,totalImage,frame=1,totalImageByte;
	long startTime,lastSecond,lastByte;
	Calendar cal = new GregorianCalendar();
	int slowMotion=0;
	Socket srtcp,s;
	MulticastSocket ms,msctrl;
	InetAddress ip;
	int port=0,ttl=255;
	int RECORD_STATE_STOPPED=0;
	int RECORD_STATE_RECORDING=1;
	int RECORD_STATE_PAUSED=2;
	boolean isUDP=false;
	int lastRTPSeqNumber=-1;
	 		
	public AppShareClient(Socket s1,Socket s2)
	{
		s=s1;
		srtcp=s2;
	}
	public AppShareClient(InetAddress address,int port,boolean isEvent)
	{
		ip = address;
		this.port = port;
		if (address.isMulticastAddress()) isUDP = true; 
		go(isEvent);
	}
	
	
	public void go(boolean isEvent)
	{
		try
		{			
		rs = new RTPStream(101);
		if (s!=null){
			rs.setSockets(s, srtcp);
		}
		else if (isUDP)
		{
			rs.setRemoteAddress(ip, port, RTPStream.UDP_MODE);
			rs.setReliabilityLevel(RTPStream.FULL_RELIABILITY);//RTPStream.ONE_NACK);
			//rs.setReliabilityLevel(RTPStream.ONE_NACK);
		}
		else
		{
			rs.setRemoteAddress(ip, port, RTPStream.TCP_MODE);
		}

		

		DataInputStream dis=null;
		/*if (!isUDP)
		{
			InputStream is = s.getInputStream();
			BufferedInputStream bis = new BufferedInputStream(is);
			dis = new DataInputStream(bis);
		}
		*/
		//System.out.println("isMark:"+dis.markSupported());
		boolean isRun=true;
		ByteBuffer bb;
		Iterator readers = ImageIO.getImageReadersByFormatName("png"); 
		ImageReader reader = (ImageReader)readers.next();
		ImageReadParam irp=reader.getDefaultReadParam();
			//System.out.println(irp+"");
		//int rtpLen=0;
		//byte[] rtpHeader = new byte[12];
		RTPMessage rtpMes;
		byte[] buffer = new byte[1024*1024*10];
		startTime = System.currentTimeMillis();
		lastSecond = 0;
		long xTime;
		int code,id,recLen;
		ByteArrayOutputStream recordBAOS= new ByteArrayOutputStream();
		DataOutputStream recordDOS = new DataOutputStream(recordBAOS);
		byte[] recordBuf=new byte[65536];
		boolean isRecord=false;
		byte[] dpBuffer=new byte[65536];
		DatagramPacket dp=null;// = new DatagramPacket(dpBuffer,dpBuffer.length);
		boolean isSpeedTest=false; int STlen=0,STnum=0; long STstartTime=0,STfinishTime=0,STsb=0,STfb=0;
		while(isRun)
		{
			/*if (isUDP){
				dp = new DatagramPacket(dpBuffer,dpBuffer.length);
				ms.receive(dp);
				dis = new DataInputStream(new ByteArrayInputStream(dp.getData(),dp.getOffset(),dp.getLength()));
				//System.out.println("len:"+dp.getLength());
				rtpLen = dp.getLength();
			}
			else rtpLen = dis.readUnsignedShort();
			*/
			if (isSpeedTest){
				//STlen+=rtpLen+2;
				//dis.readFully(recordBuf,0,rtpLen);
				//System.out.print("*");
				if (System.currentTimeMillis()-STfinishTime>1000) {
					System.out.println(""+(STfinishTime-STstartTime)+" ms "+(STsb/1024)+" KB\t"+((STsb-STnum*(14+8+12+13+12+24))/1024)+" KB\t"+(STsb)/(STnum+1)+" KB/p "+STnum);
					STstartTime=System.currentTimeMillis();
					STsb=0; STnum=0;
				}
				
				//if (rtpLen>10000){
				//	System.out.println("BIG:"+(System.currentTimeMillis()-STfinishTime)+" ms "+(rtpLen/1024)+" KB\t");
				//}
				//else {
					STfinishTime=System.currentTimeMillis();
					//STsb+=rtpLen+2;
					STnum++;
				//}
				continue;
			}
			//dis.readFully(rtpHeader);
			rtpMes = rs.read();
			dis = new DataInputStream(new ByteArrayInputStream(rtpMes.data, 0, rtpMes.data.length));
			//if (dl > 0)  System.out.println("rtpLen:" + rtpLen + " rtpHeader:" + rtpMes);
			if (rtpMes.seqNumber<lastRTPSeqNumber) System.out.println("OUT OF ORDER"+ rtpMes.seqNumber+" "+lastRTPSeqNumber);
			lastRTPSeqNumber=rtpMes.seqNumber;
			code = dis.readInt();
			id = dis.readInt();
			if (id>MAX_WINDOW||id<0||(windows[id]==null&&code!=0)||(windows[id]!=null&&code==0)){
				dis.readFully(buffer,0,rtpMes.length-8);
				if (id>MAX_WINDOW||id<0){}
				else if (windows[id]==null){
					System.out.println("There is no window with id:"+id);
					if (isUDP) rs.rtcp.sendFIR();//dp.getAddress(),dp.getPort()+1);
				}else{
					System.out.println("There is already a window with id:"+id);
				}
				continue;
			}  
			if (windows[id]!=null)	windows[id].lastTS=rtpMes.timeStamp;
			if (windows[id]!=null&&windows[id].RECORD_STATE==RECORD_STATE_RECORDING){
				recordBAOS.reset();
				dis.mark(rtpMes.length-8);
				//recordDOS.writeShort((short)(rtpLen));
				recordDOS.write(rtpMes.header, 0, rtpMes.header.length);
				recordDOS.writeInt(code);
				recordDOS.writeInt(id);
				dis.readFully(recordBuf, 0, rtpMes.length-8);
				recordDOS.write(recordBuf, 0, rtpMes.length - 8);
				windows[id].r.write(recordBAOS.toByteArray(),(int)rtpMes.timeStamp);
				dis.reset();
				isRecord=true;
			}
			if (dl>0) System.out.println("Code:"+code);
			
			
			if (code==0)
			{
				//int id =dis.readInt();
				System.out.println("New Window id:"+id);
				windows[id]= new AppShareWindow(isEvent);
				if (isEvent) 
				{
					if (isUDP) ip=rs.getRemoteAddress();
					BFCP_Client bfcpcli = new BFCP_Client(ip,rs,this,windows[id]); 
					windows[id].bfcpcli=bfcpcli;
				}
				windows[id].initialize();
				//windows[id].getContentPane().add(windows[id].label);
				//windows[id].setUndecorated(true);
				windows[id].pack();
				windows[id].setVisible(true);
			}
			else if (code==1)
			{
				System.out.println("Close Window "+dis.readInt());
			}
			else if (code==2)
			{
				int w,h;
				windows[id].left = dis.readInt();
				windows[id].top = dis.readInt();
				w =dis.readInt();
				h =dis.readInt();
				
				if (w==windows[id].bi.getWidth()&&h==windows[id].bi.getHeight()) System.out.println("Same Size id:"+id+" w:"+w+" h:"+h);
				else{
				//	System.out.println("New Size id:"+id+" w:"+w+" h:"+h);
					int type=BufferedImage.TYPE_3BYTE_BGR;
					if (windows[id].bi.getType()!=BufferedImage.TYPE_CUSTOM) type=windows[id].bi.getType();
					windows[id].bi = new BufferedImage(w, h, windows[id].bi.getType());
					windows[id].label.bi = windows[id].bi;
					windows[id].pack();
				}
			}
			else if (code==3)
			{
				int l,t,w,h,len,index=0;
				//id =dis.readInt();
				l =dis.readInt();
				t =dis.readInt();
				w =dis.readInt();
				h =dis.readInt();
				boolean isFinished=false;
				//if (dl>0); System.out.println("BitBlt id:"+id+" x+"+l+" y:"+t+" w:"+w+" h:"+h+ " byte:"+w*h*3+" Len:"+(rtpLen-12-24)+" rtp:"+rtpMes.seqNumber);
				totalImage++;
				try
				{
					len = rtpMes.length  - 24;
					if (len>0) dis.readFully(buffer,index,len);
					index+=len;
					if (rtpMes.markerBit) isFinished=true;
					
					while(!isFinished)
					{
						/*if (isUDP)
						{
							dp = new DatagramPacket(dpBuffer,dpBuffer.length);
							ms.receive(dp);
							dis = new DataInputStream(new ByteArrayInputStream(dp.getData(),dp.getOffset(),dp.getLength()));
							rtpLen = dp.getLength();
						}
						else rtpLen = dis.readUnsignedShort();
						dis.readFully(rtpHeader);
						 */
						rtpMes = rs.read();
						dis = new DataInputStream(new ByteArrayInputStream(rtpMes.data, 0, rtpMes.data.length));
						if (rtpMes.seqNumber<lastRTPSeqNumber) System.out.println("OUT OF ORDER"+ rtpMes.seqNumber+" "+lastRTPSeqNumber);
						lastRTPSeqNumber=rtpMes.seqNumber;
						len = rtpMes.length;
						if (dl > 0)  System.out.println("PNG READ index:" + index + " len:" + len + " RTP" + rtpMes);
						if (len>0) dis.readFully(buffer,index,len);
						if (isRecord)
						{
							recordBAOS.reset();
							//recordDOS.writeShort((short)(rtpLen));
							recordDOS.write(rtpMes.header,0,rtpMes.header.length);
							recordDOS.write(buffer,index,len);
							windows[id].r.write(recordBAOS.toByteArray(),(int)rtpMes.timeStamp);
						}
						index+=len;
						if (rtpMes.markerBit) isFinished=true;
					}
					isRecord=false;
					//System.out.println("PNG IMAGE len:"+index);
					if (index>60000) {
						frame++;
						totalImageByte+=index;
					}
					totalByte+=index;
					if ((System.currentTimeMillis()-startTime)/1000!=lastSecond)
					{
						long diffTime=(System.currentTimeMillis()-startTime)/1000-lastSecond;
						lastSecond = (System.currentTimeMillis()-startTime)/1000;
						cal = new GregorianCalendar();
					//	System.out.println("\n"+cal.get(Calendar.HOUR_OF_DAY)+":"+
						//				   cal.get(Calendar.MINUTE)+":"+cal.get(Calendar.SECOND)+" Img:"+totalImage+" KB:"+totalByte/1024+" Sec:"+lastSecond+
							//			   " AvgImg:"+totalImageByte/frame+" AvgKB:"+totalByte/lastSecond+"           KB:"+(totalByte-lastByte)/(1024*diffTime)+" "+diffTime+"sec");
					//	System.out.println(rs.getStats());
						lastByte = totalByte;
					}
				}
				
				catch(Exception e)
				{
					e.printStackTrace();
					System.exit(0);
				}
				try
				{
					//byte[] b= new byte[len];
					//dis.readFully(b);
					//new ByteArrayInputStream(buffer,0,index);
					//BufferedImage bf = ImageIO.read();
					//System.out.println("Reading PNG image");
					irp.setDestination(windows[id].bi);
					irp.setDestinationOffset(new Point(l,t));
					//FileOutputStream fos = new FileOutputStream(l+"_"+t+".png");
					//fos.write(buffer,0,index);
					ByteArrayInputStream bais=new ByteArrayInputStream(buffer,0,index);
					ImageInputStream iis=new MemoryCacheImageInputStream(bais);
					//SeekableStream s = SeekableStream.wrapInputStream(bais, true);
					//ImageInputStream iis=ImageIO.createImageInputStream(bais);
					reader.setInput(iis, false, true);
					try
					{
						BufferedImage bf = reader.read(0, irp);
					}
					catch (IllegalArgumentException iae) {
						BufferedImage bf = reader.read(0);
						if (bf.getType()!=BufferedImage.TYPE_CUSTOM){
							windows[id].bi = new BufferedImage(windows[id].bi.getWidth(), windows[id].bi.getHeight(),bf.getType());
							windows[id].bi.getRaster().setRect(l, t, bf.getRaster());
							windows[id].label.bi = windows[id].bi;
							windows[id].pack();
						}
						else{
						//	windows[id].bi.getRaster().setRect(l,t,bf.getRaster());
							windows[id].bi.setRGB(l,t,bf.getWidth(),bf.getHeight(), bf.getRGB(0,0,bf.getWidth(),bf.getHeight(),null,0,bf.getWidth()) ,0,bf.getWidth());
						}
					}
					//System.out.println("PNG IMAGE l"+l+" T:"+t+" h:"+bf.getHeight()+" w:"+bf.getWidth()+" len:"+index+" "+w+" "+h);
					//windows[id].bi.getRaster().setRect(l,t,bf.getRaster());
					windows[id].label.repaint(l,t,w,h);
					
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}
			}
			else if (code == 4)
			{ 
				int  w, h;
				//id = dis.readInt();
				windows[id].left = dis.readInt();
				windows[id].top = dis.readInt();
			//	System.out.println("Moved id:" + id + " l:" + windows[id].left + " t:" + windows[id].top);
				//windows[id].validate();
			}
			else if (code == 10)
			{
				int  srcx, srcy,destl,destr,destt,destb;
				//id = dis.readInt();
				srcx = dis.readInt();
				srcy = dis.readInt();
				destl=dis.readInt();
				destr=dis.readInt();
				destt=dis.readInt();
				destb=dis.readInt();
				
			//	System.out.println("MoveRect id:" + id + " x:"+srcx+" y:"+srcy+" l:" + destl +" r:" + destr + " t:" + destt+ " b:" + destb);
				//windows[id].status.setText("MoveRect id:" + id + "x:"+srcx+" y:"+srcy+" l:" + destl +" r:" + destr + " t:" + destt+ " b:" + destb);
				Thread.sleep(slowMotion);
				try
				{
					windows[id].bi.getRaster().setRect(destl-srcx,destt-srcy,windows[id].bi.getData(new Rectangle(srcx,srcy,destr-destl,destb-destt)));
				}
				catch(ArrayIndexOutOfBoundsException e){
					System.out.println("----------\n"+e);
					e.printStackTrace();
				}
				catch(IllegalArgumentException e)
				{
					System.out.println("----------\n"+e);
					e.printStackTrace();
				}
				//if ((xTime=System.currentTimeMillis())-windows[id].lastRefreshTime>windows[id].refreshTime)
				//{
					//refreshNow(id,destl,destt,destr-destl,destb-destt);
					//refreshNow(id,srcx,srcy,destr-destl,destb-destt);
				windows[id].label.repaint(destl,destt,destr-destl,destb-destt);
				windows[id].label.repaint(srcx,srcy,destr-destl,destb-destt);

				//}
				
				
				//windows[id].validate();
			}
			else{
				//e.printStackTrace();
				System.exit(0);
			}
		}
		
		//JLabel label = new JLabel(new ImageIcon(bi));
		
		
		
	}
		catch(Exception e)
	{
			e.printStackTrace();
			//System.exit(0);
	}
		for (int x=0;x<windows.length;x++){ 
			//if (windows[x]!=null) {
			//	windows[x].dispose();
			//	windows[x]=null;
			//}
			if (windows[x]!=null) windows[x].status.setText("Connection Lost.");
		}
		System.out.println("CONNECTION LOST.");
		
	}
	
	public synchronized void refreshNow(int id,int x,int y,int w,int h){
		System.out.println("Refresh at x:"+x+" y:"+y+" w:"+w+" h:"+h);
		long xTime=System.currentTimeMillis();
		windows[id].label.repaint(x,y,w,h);
		//windows[id].lastRefreshTime=System.currentTimeMillis();
		//xTime=windows[id].lastRefreshTime-xTime;
		//windows[id].refreshTime=(int)xTime*4;
		//if (windows[id].refreshTime<25) windows[id].refreshTime=25;
		//System.out.println("Refresh at "+windows[id].lastRefreshTime+" rft:"+xTime+"\n");
	}
	
	class DisplayComp extends Component{
		BufferedImage bi;
		Rectangle r=new Rectangle();
		public DisplayComp(BufferedImage bix){
			bi=bix;
		}
		
		public Dimension getPreferredSize() {
			return new Dimension(bi.getWidth(), bi.getHeight());
		}
		
		public void paint(Graphics g) {
			r=g.getClipBounds(r);
			//System.out.println("Paint x:"+r.getX()+" y:"+r.getY()+" w:"+r.getWidth()+" h:"+r.getHeight());
			/*
			g.drawImage(bi,
						(int)r.getX(), (int)r.getY(),(int) (r.getWidth()-r.getX()), (int)(r.getHeight()-r.getY()),
						(int)r.getX(), (int)r.getY(), (int)(r.getWidth()-r.getX()),(int) (r.getHeight()-r.getY()),
						null);
						*/
			g.drawImage(bi,0,0,null);			
			//super.paint(g);
		}
		
		
	}
	
	class AppShareWindow extends JFrame
	{
		int RECORD_STATE=RECORD_STATE_STOPPED;
		BFCP_Client bfcpcli;
		BufferedImage bi; 
		DisplayComp label;
		JLabel status;//,label;
		JButton control=new JButton("Control"),decorate=new JButton("Border"),fullScreen=new JButton("Full Screen");
		JPanel bottom=new JPanel(),bottomMiddle=new JPanel();
		JPanel recPanel=new JPanel();
		JButton record=new JButton(">"),stop=new JButton("[]");
		JPanel centre=new JPanel();
		int left, top;
		boolean decor=true,fs=false;
		final int NO_CONTROL=0;
		final int REQUEST_CONTROL=1;
		final int YES_CONTROL=2;
		int state = NO_CONTROL;
		boolean isEvent;
		JScrollPane scrollPane;
		Recorder r;
		long lastTS;

		public AppShareWindow(boolean isEventX){
			isEvent=isEventX;
			
		}
		
		public void myRequestFocus(){
			label.requestFocus();
		}
		
		public void setControlState(int statex,String info){
			state=statex;
		//	System.out.println("setControlState:"+state);
			if (state==NO_CONTROL) control.setIcon(new ImageIcon("images/reds.png"));
			else if (state==YES_CONTROL) 
			{
				control.setIcon(new ImageIcon("images/greens.png"));
				status.setText(info);
			}
			else if (state==REQUEST_CONTROL)
			{
				control.setIcon(new ImageIcon("images/yellows.png"));
				status.setText(info);
			}
		}

		public void generateFullScreen(RecordFullScreenInterface rfsi){
			try
			{
				ByteArrayOutputStream baos= new ByteArrayOutputStream();
				DataOutputStream dos=new DataOutputStream(baos);
				RTPStream rsrecord = new RTPStream(110);
							
				//dos.writeShort((short)(12+8));
				dos.write(rsrecord.getRTPHeader(lastTS-20),0,12);
				dos.writeInt(0);
				dos.writeInt(1);
				rfsi.write(baos.toByteArray(),(int)lastTS-20);
				baos.reset();

				//dos.writeShort((short)(12+24));
				dos.write(rsrecord.getRTPHeader(lastTS-20),0,12);
				dos.writeInt(2);
				dos.writeInt(1);
				dos.writeInt(left);
				dos.writeInt(top);
				dos.writeInt(bi.getWidth());
				dos.writeInt(bi.getHeight());
				rfsi.write(baos.toByteArray(),(int)lastTS-20);
				baos.reset();

				int scanLineCount,PacketLimit=1000;
				if (PacketLimit==-1)  scanLineCount=bi.getHeight();
				else scanLineCount = ( PacketLimit/bi.getWidth())+1;
				int isSmaller=0;

				for (int sl=0;sl<(bi.getHeight());sl+=scanLineCount)
				{
					if (isSmaller>2)
					{
						scanLineCount++;
						isSmaller =0;
					}
					else if (isSmaller==-1&&scanLineCount>1){
						scanLineCount--;
						isSmaller =0;
					}

					if (sl+scanLineCount>bi.getHeight()) scanLineCount=bi.getHeight()-sl;
					
					//dos.writeShort((short)(12+24));
					//dos.write(rsrecord.getRTPHeader(lastTS-20),0,12);
					
					//byte[] header = baos.toByteArray();
					//System.out.println(""+header[3]);
					//rfsi.write(baos.toByteArray(),(int)lastTS-20);
					//baos.reset();
							
					ImageIO.write(bi.getSubimage(0,sl,bi.getWidth(),scanLineCount),"PNG",baos);
					byte[] image=baos.toByteArray();
					if (image.length<PacketLimit) isSmaller++;
					else if (image.length>PacketLimit) isSmaller=-1;
					//FileOutputStream fos = new FileOutputStream(sl+".png");
					//fos.write(image,0,image.length);
					baos.reset();
					int offset=0,remaining=0;
					while(offset<image.length)
					{
						remaining=image.length-offset;
						if (remaining>64000) remaining=64000;
						if (offset+remaining==image.length) rsrecord.isMarker(true);
						//if (offset==0) dos.writeShort((short)(12+remaining+24));
						//else dos.writeShort((short)(12+remaining));
						dos.write(rsrecord.getRTPHeader(),0,12);
						if (offset==0){
							dos.writeInt(3);
							dos.writeInt(1);
							dos.writeInt(0);
							dos.writeInt(sl);
							dos.writeInt(bi.getWidth());
							dos.writeInt(scanLineCount);
						}
						rsrecord.isMarker(false);
					//	System.out.println("off:"+offset+" "+remaining+" scl:"+scanLineCount);
						dos.write(image,offset,remaining);
						offset+=(rfsi.write(baos.toByteArray(),(int)lastTS-20)-14);
						baos.reset();
					}
				}

			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
			//rfsi.finished();
		}
		
		public void initialize(){
			bottom.setLayout(new BorderLayout());
			bottomMiddle.setLayout(new BoxLayout(bottomMiddle, BoxLayout.LINE_AXIS) );
			setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			//setBounds(720, 320,10, 10);
			bi = new BufferedImage(10,10, BufferedImage.TYPE_3BYTE_BGR);
			label = new DisplayComp(bi);//new JLabel(new ImageIcon(bi));
			
			label.setFocusTraversalKeysEnabled(false);
			scrollPane = new JScrollPane(label);
			getContentPane().add(scrollPane,BorderLayout.CENTER);
			
			status=new JLabel("status");
			
			bottomMiddle.add(fullScreen);
			bottomMiddle.add(status);
			bottom.add(bottomMiddle,BorderLayout.CENTER);
			bottom.add(control,BorderLayout.EAST);
			control.setIcon(new ImageIcon("images/reds.png"));
			
			recPanel.add(record);
			recPanel.add(stop);
			bottomMiddle.add(recPanel);

			if (isEvent)
			{
				label.addMouseListener(bfcpcli.getMyEvents());
				label.addKeyListener(bfcpcli.getMyEvents());
				label.addMouseMotionListener(bfcpcli.getMyEvents());
				label.addMouseWheelListener(bfcpcli.getMyEvents());
			}
			else{
				control.setEnabled(false);
			}
			
			
			bottom.add(decorate,BorderLayout.WEST);
			//bottom.add(fullScreen,BorderLayout.WEST);
			//bottom.add(test,BorderLayout.SOUTH);
			getContentPane().add(bottom,BorderLayout.SOUTH);
			
			fullScreen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt){
					if (fs){
						dispose();
						GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
						GraphicsDevice myDevice = ge.getDefaultScreenDevice();
						setResizable(true);
						myDevice.setFullScreenWindow(null);
						decorate.setEnabled(true);
						getContentPane().add(bottom,BorderLayout.SOUTH);
						getContentPane().remove(label);
						getContentPane().add(scrollPane,BorderLayout.CENTER);
						
						if (!isEvent){
							//getContentPane().remove(bottom);
						}
						setUndecorated(false);
						pack();
						fs=false;
						setVisible(true);
					}else{
						dispose();
						getContentPane().remove(bottom);
						getContentPane().remove(scrollPane);
						getContentPane().add(label,BorderLayout.CENTER);
						setUndecorated(true);
						//setIgnoreRepaint(true);
						setResizable(false);
						decorate.setEnabled(false);
						GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
						GraphicsDevice myDevice = ge.getDefaultScreenDevice();
						
						try {
							System.out.println(myDevice.isFullScreenSupported()+" x ");
							myDevice.setFullScreenWindow(AppShareWindow.this);
						} catch(Exception e){
							e.printStackTrace();
						}finally {
							System.out.println(myDevice.isFullScreenSupported()+" PROBLEM  ");
							//myDevice.setFullScreenWindow(null);
						}
						fs=true;
						//pack();
						//setVisible(true);
						validate();
					}
			}
									   });
			
			decorate.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt){
					if (decor){
						dispose();
						if (!isEvent){
							getContentPane().remove(bottom);
						}
						setUndecorated(true);
						pack();
						decor=false;
						setVisible(true);
					}else{
						dispose();
						setUndecorated(false);
						decor=true;
						pack();
						setVisible(true);
					}
			}
									   });

			record.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent evt)
				{
					if (RECORD_STATE==RECORD_STATE_RECORDING)
					{
						RECORD_STATE=RECORD_STATE_PAUSED;
						rs.removeRecorder(r);
						record.setText(">");
					}
					else if(RECORD_STATE==RECORD_STATE_PAUSED)
					{
						RECORD_STATE=RECORD_STATE_RECORDING;
						rs.addRecorder(r);
						record.setText("||");
					}
					else if(RECORD_STATE==RECORD_STATE_STOPPED)
					{
						
						r= new Recorder();
						generateFullScreen(r);
						RECORD_STATE=RECORD_STATE_RECORDING;
						rs.addRecorder(r);
						record.setText("||");
						status.setText("Recording...");
					}
				}
			});

			stop.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent evt)
				{
					if (RECORD_STATE==RECORD_STATE_RECORDING||RECORD_STATE==RECORD_STATE_PAUSED)
					{
						RECORD_STATE=RECORD_STATE_STOPPED;
						rs.removeRecorder(r);
						record.setText(">");
						r.close();
						status.setText("Recording saved to file.");
					}
				}
			});

			
			control.addActionListener(new ActionListener()
									  {
				public void actionPerformed(ActionEvent evt)
			{
					if (state==NO_CONTROL)
					{
						bfcpcli.request();
					}
					else
					{
						bfcpcli.release();
					}
			}
									  });
			
			validate();
		}
		
		
	}
	
	static class Listener extends Thread
	{
		int port=6000;
		boolean isEvent;
		AppShareClient asc=null;

		public Listener(int rtpPort){
			port=rtpPort;
		}

		public Listener(){}

		public Listener(boolean isEvent){
			this.isEvent=isEvent;
		}

		class Helper extends Thread{
			Socket socket1,socket2;
			
			public Helper(Socket s1,Socket s2){
				socket1=s1;
				socket2=s2;
			}
			
			public void run(){
				asc=new AppShareClient(socket1,socket2);
				asc.go(isEvent);
			}
		}
		
		public void run()
	{
			//int port1 = 6000,port2=6001;
			ServerSocket srv1=null,srv2=null;
			try 
			{  
				srv1 = new ServerSocket(port); 
				srv2 = new ServerSocket(port+1); 
			} 
			catch (Exception e) 
			{
				e.printStackTrace();
				System.exit(0);
			}
			while(true)
			{
				try 
			{  
				Socket socket1 = srv1.accept();
				socket1.setTcpNoDelay(true);
				socket1.setKeepAlive(true);
				System.out.println("NEW CONNECTION "+socket1);
				Socket socket2 = srv2.accept();
				socket2.setTcpNoDelay(true);
				socket2.setKeepAlive(true);
				System.out.println("\n"+socket2);
				new Helper(socket1,socket2).start();
				sleep(Integer.MAX_VALUE);
			} 
				catch (Exception e) 
			{
					e.printStackTrace();
			}
			}
			
			
	}
		
	}
	public static void main(String[] args)
	{
		boolean isEvent=false,isListener=false;
		InetAddress address=null;
		int port=0;
		if (args.length>0) 
		{
			for (int x=0;x<args.length;x++)
			{
				//System.out.println("'''"+args[x]);
				if (args[x].equals("-e"))
				{
					isEvent=true;
				}
				else if(args[x].equalsIgnoreCase("-l"))
				{
					isListener=true;
				}
				else
				{
					//System.out.println("..."+args[x]);
					StringTokenizer st = new StringTokenizer(args[x],"/");
					try
					{
						if (st.hasMoreTokens()) address=InetAddress.getByName(st.nextToken());
						if (st.hasMoreTokens()) port=Integer.parseInt(st.nextToken());
					}
					catch(Exception e){e.printStackTrace();}
				}
			}
			
		}
		else System.out.println("usage: java AppShareClient [-l] [-e] [adddress/port]");
		System.out.println(isListener+" "+isEvent+" "+address+" "+port);
		if (isListener){
			Listener l;
			l=new Listener(isEvent);
			l.start();
		}
		else if (address!=null){
			new AppShareClient(address,port,isEvent);
		}
	}
	
	
}