package ppt;

import java.io.*;
import java.net.*;
import java.awt.event.*;

public class BFCP_Client implements Runnable {
	DataOutputStream eventStream,controlOutputStream;
	DataInputStream controlInputStream;
	AppShareClient asc;
	AppShareClient.AppShareWindow w;
	MyEvents myEvents;
	RTPStream rs;
	final int STATE_KEYBOARD_ALLOWED = 1;
	final int STATE_MOUSE_ALLOWED = 2;
	final int STATE_ALL_ALLOWED = 3;
	final int STATE_NOT_ALLOWED = 0;

	final int NO_CONTROL=0;
	final int REQUEST_CONTROL=1;
	final int YES_CONTROL=2;
	int state = NO_CONTROL;
	int dl=0;
	int transID,userID;
	

	public MyEvents getMyEvents(){
		return myEvents;
	}

	public BFCP_Client(InetAddress ip,RTPStream rs1,AppShareClient ascCB,AppShareClient.AppShareWindow w1){
		asc=ascCB;
		rs=rs1;
		w=w1;
		transID=0;
		userID=12;
		try
		{
			Socket sControl= new Socket(ip,6004);
			sControl.setTcpNoDelay(true);
			controlInputStream = new DataInputStream(sControl.getInputStream());
			controlOutputStream = new DataOutputStream(sControl.getOutputStream());
			
			Socket sEvent= new Socket(ip,6002);
			sEvent.setTcpNoDelay(true);
			eventStream = new DataOutputStream(sEvent.getOutputStream());
			
			myEvents = new MyEvents(w1);
			new Thread(this).start();
		}
		catch(Exception e)
		{
			System.out.println("555 "+e);
			e.printStackTrace();
		}
	}

	public void request(){
		try
		{
			byte[] message=new byte[16];
			w.setControlState(REQUEST_CONTROL,"Sending Request.");
			message[0]=32;			message[1]=1;				message[2]=0;			message[3]=1;
			message[4]=0;			message[5]=0;				message[6]=0;			message[7]=0;
			message[8]=0;			message[9]=(byte)transID;	message[10]=0;			message[11]=(byte)userID;
			message[12]=4;			message[13]=4;				message[14]=0;			message[15]=0;
			controlOutputStream.write(message,0,message.length);
			
		}
		catch(SocketException se)
		{
			System.out.println("111 "+se);
			System.exit(0);
		}
		catch(Exception e){
			System.out.println("1134 "+e);
			e.printStackTrace();
		}
	}

	public void release()
	{
		try{
			byte[] message=new byte[16];
			message[0]=32;			message[1]=2;				message[2]=0;			message[3]=1;
			message[4]=0;			message[5]=0;				message[6]=0;			message[7]=0;
			message[8]=0;			message[9]=(byte)transID;	message[10]=0;			message[11]=(byte)userID;
			message[12]=4;			message[13]=4;				message[14]=0;			message[15]=0;
			controlOutputStream.write(message,0,message.length);
			w.setControlState(NO_CONTROL,"Control released.");
		}
		catch(SocketException se)
		{
			System.out.println("1521 "+se);
			System.exit(0);
		}
		catch(Exception e)
		{
			System.out.println("23452 "+e);
		}
	}

	public void run(){
		int queue,KMcode;
		byte[] header=new byte[12];
		byte[] other=null;

		while(true){
			try{
				controlInputStream.readFully(header,0,12);
				System.out.println("\n\n\n\nNEW MESSAGE FROM SERVER");
				if (header[3]>0)
				{
					other=new byte[header[3]*4];
					controlInputStream.readFully(other,0,header[3]*4);
					//System.out.println("Other Info attribute:" +other[0]/2+ " len:"+other[1]+" bytes.byte3:"+other[2]+" byte4:"+other[3]);
				}
				if (header[1]!=4) {
					System.out.println("BFCP Primitive " + header[1]+" is not supported.");
					continue;
				}
				//code = controlInputStream.readByte();
				//System.out.println("BFCP_Client Code: " + code);
				if (other[10]==2)
				{
					state = REQUEST_CONTROL;
					queue=other[11];
					w.setControlState(REQUEST_CONTROL,"Queue Position:"+queue);
				}
				else if (other[10]==3){
					state = YES_CONTROL;
					KMcode=-1;
					if (other.length==16&&other[12]==60) KMcode=other[15];
					System.out.println("other[15]"+other[15]);
					if (KMcode==STATE_ALL_ALLOWED) w.setControlState(YES_CONTROL,"Mouse and keyboard actions are allowed.");
					else if (KMcode==STATE_KEYBOARD_ALLOWED) w.setControlState(YES_CONTROL,"Only keyboard actions are allowed.");
					else if (KMcode==STATE_MOUSE_ALLOWED) w.setControlState(YES_CONTROL,"Only Mouse actions are allowed.");
					else if (KMcode==STATE_NOT_ALLOWED) w.setControlState(YES_CONTROL,"Mouse and keyboard actions are temprorarily disabled.");
					else w.setControlState(YES_CONTROL,"Control granted.");
				}
				else if (other[10]==6)
				{
					state = NO_CONTROL;
					w.setControlState(NO_CONTROL,"Control released.");
				}
			}
			catch(SocketException e)
			{
				System.out.println("333 "+e);
				break;
			}
			catch(java.io.EOFException eof)
			{
				System.out.println("555 "+eof);
				break;
			}
			catch(Exception ex)
			{
				System.out.println("444 "+ex);
			}
		}
	
	}

	class MyEvents implements MouseListener,MouseMotionListener,KeyListener,MouseWheelListener 
	{
		AppShareClient.AppShareWindow w;
		
		public MyEvents(AppShareClient.AppShareWindow window) 
		{ 
			w = window; 
		}

		
		public void	mouseClicked(MouseEvent e)  
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				//eventStream.writeByte(2);
				//eventStream.writeInt(e.getX() + w.left);
				//eventStream.writeInt(e.getY() + w.top);
				//eventStream.flush();
			}
			catch (Exception ioe) 
			{
				System.out.println(ioe + "\n");
			}
		}
		
		public void	mouseEntered(MouseEvent e)  { if (dl>0) System.out.println(e+"\n");}
		
		public void	mouseExited(MouseEvent e)   {if (dl>0) System.out.println(e+"\n");}
		
		public void	mousePressed(MouseEvent e)  
		{
			
			try
			{
				if (dl>0) System.out.println(e+"\n");
				w.myRequestFocus();
				if (state == YES_CONTROL)
				{
					//if (dl>0) System.out.println(e+"\n");
					writeUnsignedShort(12+1+4*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(0);
					eventStream.writeInt(e.getX() + w.left);
					eventStream.writeInt(e.getY() + w.top);
					eventStream.writeInt(e.getModifiers());
					eventStream.writeInt(e.getClickCount());
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				if (dl>0) System.out.println(ioe + "\n");
			}
		}
		
		public void	mouseReleased(MouseEvent e) 
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				if (state == YES_CONTROL)
				{
					
					writeUnsignedShort(12+1+3*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(1);
					eventStream.writeInt(e.getX() + w.left);
					eventStream.writeInt(e.getY() + w.top);
					eventStream.writeInt(e.getModifiers());
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}
		
		public void	mouseMoved(MouseEvent e)    
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				if (state == YES_CONTROL)
				{
					
					writeUnsignedShort(12+1+2*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(2);
					eventStream.writeInt(e.getX() + w.left);
					eventStream.writeInt(e.getY() + w.top);
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}

		public void	mouseDragged(MouseEvent e) 	
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				if (state == YES_CONTROL)
				{
					
					writeUnsignedShort(12+1+2*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(3);
					eventStream.writeInt(e.getX() + w.left);
					eventStream.writeInt(e.getY() + w.top);
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}

		public void	mouseWheelMoved(MouseWheelEvent e) 	
		{
			try
            {
				if (dl>0) System.out.println(e + "-123-\n");
				if (state == YES_CONTROL)
				{
					
					writeUnsignedShort(12+1+3*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(4);
					eventStream.writeInt(e.getX() + w.left);
					eventStream.writeInt(e.getY() + w.top);
					eventStream.writeInt(e.getWheelRotation());
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}

		
		
		public void	keyPressed(KeyEvent e)		
		{
			try
			{
				System.out.println(e + "\n");
				if (state == YES_CONTROL)
				{
					if (dl>0) System.out.println(e + "\n");
					writeUnsignedShort(12+1+1*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(10);
					eventStream.writeInt(e.getKeyCode());
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}
		
		public void	keyReleased(KeyEvent e)		
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				if (state == YES_CONTROL)
				{
					if (dl>0) System.out.println(e + "\n");
					writeUnsignedShort(12+1+1*4);
					eventStream.write(rs.getRTPHeader());
					eventStream.writeByte(11);
					eventStream.writeInt(e.getKeyCode());
					eventStream.flush();
				}
			}
			catch (IOException ioe)
			{
				System.out.println(ioe + "\n");
			}
		}
		
		public void	keyTyped(KeyEvent e)		
		{
			try
			{
				if (dl>0) System.out.println(e + "\n");
				//eventStream.writeByte(12);
				//eventStream.writeInt(e.getKeyCode());
				//eventStream.flush();
			}
			catch (Exception ioe)
			{
				System.out.println(ioe + "\n");
			}
		}
	}

	public void writeUnsignedShort(int length)
	{
		try
		{
			eventStream.write((byte)(0xFF & (length>>8)));
			eventStream.write((byte)(0xFF & (length)));
		}
		catch (Exception ioe)
		{
			System.out.println(ioe + "\n");
		}
	}



}
