package ppt;

public class RTPMessage{
	int seqNumber;
	long timeStamp;
	long ssrc;
	byte[] data;
	boolean markerBit;
	int payload;
	byte[] header;
	int length;

	public RTPMessage(byte[] headerX,byte[] dataX)
	{
		header = headerX;
		data = dataX;
		length = data.length;
		int firstByte =  0;
		int secondByte = 0;
		int thirdByte =  0;
		int fourthByte = 0;
		payload = (0x000000FF & ((int)header[1]));
		if (payload>127){
			payload-=128;
			markerBit = true;
		}else{
			markerBit = false;
		}

		firstByte = (0x000000FF & ((int)header[2]));
		secondByte = (0x000000FF & ((int)header[3]));
		seqNumber  = ((int) (firstByte <<8| secondByte))& 0xFFFFFFFF;
		firstByte = (0x000000FF & ((int)header[4]));
		secondByte = (0x000000FF & ((int)header[5]));
		thirdByte = (0x000000FF & ((int)header[6]));
		fourthByte = (0x000000FF & ((int)header[7]));
		timeStamp  = ((long) (firstByte << 24| secondByte << 16	| thirdByte << 8	| fourthByte))& 0xFFFFFFFFL;

		firstByte = (0x000000FF & ((int)header[8]));
		secondByte = (0x000000FF & ((int)header[9]));
		thirdByte = (0x000000FF & ((int)header[10]));
		fourthByte = (0x000000FF & ((int)header[11]));
		ssrc  = ((long) (firstByte << 24| secondByte << 16	| thirdByte << 8	| fourthByte))& 0xFFFFFFFFL;
	}

	public RTPMessage(byte[] headerX) {
		this(headerX, new byte[0]);
	}

	public String toString(){
		return new String("marker:"+markerBit+" seqNumber:"+seqNumber+" timeStamp:"+timeStamp+" payload:"+payload);
	}
}

